#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\..\Icons\wave.ico
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Converting to wav with 48kHz 16bit.
#AutoIt3Wrapper_Res_Description=Converting to wav with 48kHz 16bit.
#AutoIt3Wrapper_Res_Fileversion=1.1.0.23
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
#AutoIt3Wrapper_Res_CompanyName=Norddeutscher Rundfunk
#AutoIt3Wrapper_Res_LegalCopyright=Conrad Zelck
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_Field=Copyright|Conrad Zelck
#AutoIt3Wrapper_Res_Field=Compile Date|%date% %time%
#AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w- 7
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/mo
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <AutoItConstants.au3>
#include <ButtonConstants.au3>
#include <Date.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <MsgBoxConstants.au3>
#include <StaticConstants.au3>
#include <File.au3>
#include <Array.au3>
#include <Sound.au3>
#include <TrayCox.au3> ; source: https://github.com/SimpelMe/TrayCox - not needed for functionality

Local $hGUI = GUICreate(StringTrimRight(@ScriptName, 4), 290, 70)
GUISetFont(10)
GUICtrlCreateLabel("Analyse...", 20, 20, 130, 30)
GUICtrlSetFont(-1, 14, 400, 0, "Lucida Sans Typewriter")
GUISetState()

Global $g_24bit = False ; for Ingest it is necessary to have 16 bit; that is default; when really pro have '24' in script name
If StringInStr(@ScriptName, "24") Then $g_24bit = True

Opt("GUICloseOnESC", 0)
FileInstall('K:\ffmpeg\bin\ffmpeg.exe', @TempDir & "\ffmpeg.exe", $FC_OVERWRITE)
Local $sPathFFmpeg = @TempDir & "\"
Global $g_sStdErrAll

Local $aCmdLineCopy = $CmdLine
Local $sAttrib
If $CmdLine[0] > 0 Then
	For $i = $CmdLine[0] To 1 Step - 1
		$sAttrib = FileGetAttrib($CmdLine[$i])
		If $sAttrib = "" Then ; all parameter not having an attribute are deleted (files and directories stay)
			_ArrayDelete($aCmdLineCopy, $i)
		EndIf
	Next
	$aCmdLineCopy[0] = UBound($aCmdLineCopy) - 1
EndIf

Local $aOneFolderFileList
Local $aFileList[0]
Local $sChoosenMedia
If $aCmdLineCopy[0] > 0 Then ; if already Files exist
	For $i = 1 to $aCmdLineCopy[0]
		$sAttrib = FileGetAttrib($aCmdLineCopy[$i])
		If StringInStr($sAttrib, "D") Then
			$aOneFolderFileList = _FileListToArrayRec($aCmdLineCopy[$i], "*.*", $FLTAR_FILES + $FLTAR_NOSYSTEM + $FLTAR_NOLINK, $FLTAR_RECUR, $FLTAR_SORT, $FLTAR_FULLPATH)
			_ArrayDelete($aOneFolderFileList, 0) ; delete Index
			_ArrayAdd($aFileList, $aOneFolderFileList)
		Else
			_ArrayAdd($aFileList, $aCmdLineCopy[$i])
		EndIf
	Next
	_ArrayInsert($aFileList, 0, UBound($aFileList))
Else ; no file in $CmdLine
	GUIDelete()
	$hGUI = GUICreate(StringTrimRight(@ScriptName, 4) & " - Auswahl", 290, 70)
	GUISetFont(10)
	Local $idButtonFiles = GUICtrlCreateButton("Dateien auswählen", 10, 20, 130, 30, $BS_DEFPUSHBUTTON)
	Local $idButtonFolder = GUICtrlCreateButton("Ordner auswählen", 150, 20, 130, 30)
	GUISetState()
	Local $msg
	While 1
        $msg = GUIGetMsg()
        If $msg = $GUI_EVENT_CLOSE Then _Beenden() ; defined at TrayCox.au3
		If $msg = $idButtonFolder Or $msg = $idButtonFiles Then ExitLoop
	WEnd
	GUIDelete()
	Switch $msg
		Case $idButtonFolder
			$sChoosenMedia = FileSelectFolder (StringTrimRight(@ScriptName, 4) & " - Ordner aussuchen", "")
			If @error Then
				MsgBox($MB_TOPMOST,StringTrimRight(@ScriptName, 4) & " - Abbruch","Keine Datei(en) ausgewählt")
				Exit
			EndIf
			$aFileList = _FileListToArrayRec($sChoosenMedia, "*.*", $FLTAR_FILES + $FLTAR_NOSYSTEM + $FLTAR_NOLINK, $FLTAR_RECUR, $FLTAR_SORT, $FLTAR_FULLPATH)
		Case $idButtonFiles
			$sChoosenMedia = FileOpenDialog(StringTrimRight(@ScriptName, 4),"", "Alle (*.*)","4")
			If @error Then
				MsgBox($MB_TOPMOST,StringTrimRight(@ScriptName, 4) & " - Abbruch","Keine Datei(en) ausgewählt")
				Exit
			EndIf
			$aFileList = StringSplit($sChoosenMedia, "|")
			If $aFileList[0] > 1 Then
				For $i = 2 To $aFileList[0]
					$aFileList[$i] = $aFileList[1] & "\" & $aFileList[$i]
				Next
				_ArrayDelete($aFileList, 1)
				$aFileList[0] = UBound($aFileList) - 1
			EndIf
	EndSwitch
EndIf
GUIDelete()
If $aFileList[0] <= 0 Then
	MsgBox($MB_TOPMOST, @ScriptName, "Es ist keine zu wandelnde Datei zu finden.")
	Exit
EndIf

$hGUI = GUICreate("Pro Audio", 600, 160)
Local $idLabelFileName = GUICtrlCreateLabel("", 10, 10, 580, 30, $SS_LEFTNOWORDWRAP)
GUICtrlSetFont(-1, 14, 400, 0, "Lucida Sans Typewriter")
Local $idLabelConvert = GUICtrlCreateLabel("Konvertiere Datei:", 10, 50, 580, 30)
GUICtrlSetFont(-1, 12, 400, 0, "Lucida Sans Typewriter")
Global $g_idProgress = GUICtrlCreateProgress(10, 80, 580, 20)
GUICtrlSetFont(-1, 14, 400, 0, "Lucida Sans Typewriter")
Local $g_hLabelRunningTime = GUICtrlCreateLabel("", 440, 120, 150, 30, $SS_RIGHT)
GUICtrlSetFont(-1, 14, 400, 0, "Lucida Sans Typewriter")
GUISetState(@SW_SHOW)

Global $hTimerStart = TimerInit()

Local $sCommand
Local $sCurTrack, $sCurTrackMinusExt, $sCurTrackNewExt
Local $iDelimiter
For $i = 1 To $aFileList[0]
	$sCurTrack = $aFileList[$i]
	GUICtrlSetData($idLabelFileName, $i & "/" & $aFileList[0] & ": " & _FileName($sCurTrack))
	$iDelimiter = StringInStr($sCurTrack, ".", 0, -1)
	$sCurTrackMinusExt = StringLeft($sCurTrack, $iDelimiter - 1)
	If  $g_24bit Then
		$sCurTrackNewExt = '_48kHz_24bit.wav'
		$sCommand = '-i "' & $sCurTrack & '" -c:a pcm_s24le -ar 48000 -y "' & $sCurTrackMinusExt & $sCurTrackNewExt & '"'
	Else
		$sCurTrackNewExt = '_48kHz_16bit.wav'
		$sCommand = '-i "' & $sCurTrack & '" -c:a pcm_s16le -ar 48000 -y "' & $sCurTrackMinusExt & $sCurTrackNewExt & '"'
	EndIf
	_runFFmpeg('ffmpeg ' & $sCommand, $sPathFFmpeg)
	GUICtrlSetData($g_idProgress, 100) ; if ffmpeg is done than set progress to 100 - sometimes last StderrRead with 100 is missed
Next
GUICtrlSetData($idLabelFileName, "Fertig. Mit [x] schliessen.")
GUICtrlSetData($idLabelConvert, "")
WinActivate($hGUI,"")
_PlayReadySound()

While 1
	Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			ExitLoop
	EndSwitch
WEnd
Exit

Func _runFFmpeg($command, $sWorkingDirectory)
	Local $hPid = Run('"' & @ComSpec & '" /c ' & $command, $sWorkingDirectory, @SW_HIDE, $STDOUT_CHILD + $STDERR_CHILD)
	Local $sStdErr, $sTimer
	Local $iTicksDuration = 0, $iTicksTime = 0, $iTimer
	While 1
		Sleep(500)
		$sStdErr = StderrRead($hPid)
		If @error Then ExitLoop
		$g_sStdErrAll &= $sStdErr
		If StringLen($sStdErr) > 0 Then
			If Not $iTicksDuration Then $iTicksDuration = _GetDuration($sStdErr)
			$iTicksTime = _GetTime($sStdErr)
			If Not @error Then $sStdErr = ""
			GUICtrlSetData($g_idProgress, $iTicksTime * 100 / $iTicksDuration)
		EndIf
		$iTimer = TimerDiff($hTimerStart)
		$sTimer = _Zeit($iTimer)
		If GUICtrlRead($g_hLabelRunningTime) <> $sTimer Then
			GUICtrlSetData($g_hLabelRunningTime, $sTimer)
		EndIf
	WEnd
EndFunc

Func _PlayReadySound()
	Local $aSound = _SoundOpen(@WindowsDir & "\media\tada.wav")
	_SoundPlay($aSound, 1)
	_SoundClose($aSound)
EndFunc

Func _GetDuration($sStdErr)
    If Not StringInStr($sStdErr, "Duration:") Then Return SetError(1, 0, 0)
    Local $aRegExp = StringRegExp($sStdErr, "(?i)Duration.+?([0-9:]+)", 3)
    If @error Or Not IsArray($aRegExp) Then Return SetError(2, 0, 0)
    Local $sTime = $aRegExp[UBound($aRegExp) - 1]
    Local $aTime = StringSplit($sTime, ":", 2)
    If @error Or Not IsArray($aTime) Then Return SetError(3, 0, 0)
    Return _TimeToTicks($aTime[0], $aTime[1], $aTime[2])
EndFunc   ;==>_GetDuration

Func _GetTime($sStdErr)
    If Not StringInStr($sStdErr, "time=") Then Return SetError(1, 0, 0)
    Local $aRegExp = StringRegExp($sStdErr, "(?i)time.+?([0-9:]+)", 3)
    If @error Or Not IsArray($aRegExp) Then Return SetError(2, 0, 0)
    Local $sTime = $aRegExp[UBound($aRegExp) - 1]
    Local $aTime = StringSplit($sTime, ":", 2)
    If @error Or Not IsArray($aTime) Then Return SetError(3, 0, 0)
    Return _TimeToTicks($aTime[0], $aTime[1], $aTime[2])
EndFunc   ;==>_GetTime


Func _FileName($sFullPath)
	Local $iDelimiter = StringInStr($sFullPath, "\", 0, -1)
	Local $sFilename, $sDisplayName
	$sFilename = StringTrimLeft($sFullPath, $iDelimiter)
	If StringLen($sFilename) > 45 Then
		$sDisplayName &= StringLeft($sFilename, 20) & "[...]" & StringRight($sFilename, 20)
	Else
		$sDisplayName = $sFilename
	EndIf
	Return $sDisplayName
EndFunc

Func _Zeit($iMs, $bComfortView = True) ; from ms to a format: "12h 36m 56s 13f" (with special space between - ChrW(8239))
	Local $sReturn
	$iMs = Int($iMs)
	Local $iFrames, $iMSec, $iSec, $iMin, $iHour, $sSign
	If $iMs < 0 Then
		$iMs = Abs($iMs)
		$sSign = '-'
	EndIf
	$iMSec = StringRight($iMs, 3)
	$iFrames = $iMSec / 40
	$iSec = $iMs / 1000
	$iMin = $iSec / 60
	$iHour = $iMin / 60
	$iMin -= Int($iHour) * 60
	$iSec -= Int($iMin) * 60
	If $bComfortView Then ; no hours if not present and no frames
		If Not Int($iHour) = 0 Then $sReturn &= StringRight('0' & Int($iHour), 2) & 'h' & ChrW(8239)
		$sReturn &= StringRight('0' & Int($iMin), 2) & 'm' & ChrW(8239)
		If Int($iHour) = 0 Then $sReturn &= StringRight('0' & Int($iSec), 2) & 's' ; zum DEBUGGING auskommentieren
	Else
		$sReturn = $sSign & StringRight('0' & Int($iHour), 2) & 'h' & ChrW(8239) & StringRight('0' & Int($iMin), 2) & 'm' & ChrW(8239) & StringRight('0' & Int($iSec), 2) & 's' & ChrW(8239) & StringRight('0' & Int($iFrames), 2) & 'f'
	EndIf
	Return $sReturn
EndFunc   ;==>_Zeit
